<template>
  <grid-container>
    <nav :class="$style.navBarWrapper">
      <div :class="$style.logo">
        <slot name="logo"></slot>
      </div>
      <div :class="$style.menuWrapper">
        <slot name="nav-items"></slot>
      </div>
      <div :class="$style.mobileMenuIcon" @click="toggleMobileMenu">
        <base-icon name="bars" :size="1.5"></base-icon>
      </div>
    </nav>
    <div v-show="isMobileMenuOpen" :class="$style.mobileMenu">
      <div :class="$style.closeIcon" @click="toggleMobileMenu">×</div>
      <div :class="$style.mobileMenuItems">
        <slot name="nav-items"></slot>
      </div>
    </div>
  </grid-container>
</template>

<script lang="ts">
import Vue from "vue";
import GridContainer from "@/components/grid/GridContainer";
import BaseIcon from "@/components/base/BaseIcon";

export default Vue.extend({
  name: "TheNavBar",
  components: {
    GridContainer,
    BaseIcon
  },
  data: function() {
    return {
      isMobileMenuOpen: false
    };
  },
  methods: {
    toggleMobileMenu: function() {
      this.isMobileMenuOpen = !this.isMobileMenuOpen;
    }
  }
});
</script>

<style module lang="scss">
.navBarWrapper {
  composes: display--flex;
  composes: justify-content--space-between;
  composes: align-items--center;
}
.menuWrapper {
  composes: display--flex;
}

.logo {
  color: $color--middle-gray;
}

.mobileMenuIcon {
  display: none;
}

@media screen and (max-width: $device-size--mobile-large) {
  .navBarWrapper {
    padding: 10px 0;
  }
  .menuWrapper {
    display: none;
  }
  .mobileMenuIcon {
    display: flex;
    color: $color--primary;
    cursor: pointer;
  }
  .mobileMenu {
    position: fixed;
    background: rgba(253, 253, 253, 0.95);
    top: 0;
    bottom: 0;
    right: 0;
    left: 0;
    z-index: 2;
  }
  .mobileMenuItems {
    composes: display--flex;
    flex-direction: column-reverse;
    margin-top: 5rem;
    cursor: pointer;
  }
  .closeIcon {
    position: absolute;
    left: 20px;
    top: 20px;
    font-size: 2rem;
  }
}
</style>
